## rear 2.9%2Bdfsg

=== Makefile ===
# In some dists (e.g. Ubuntu) bash is not the default shell. Statements like
#   cp -a etc/rear/{mappings,templates} ...
# assumes bash. So its better to set SHELL to bash explicitly, using the one from PATH
# to also work on MacOS with Homebrew-installed bash
SHELL = bash

# disable parallel execution of make
.NOTPARALLEL:

DESTDIR =
OFFICIAL =
DIST_CONTENT = COPYING  doc  etc  MAINTAINERS  Makefile  packaging  README.md  tests  tools  usr

### Get version from Relax-and-Recover itself
rearbin = usr/sbin/rear
name = rear
version := $(shell awk 'BEGIN { FS="=" } /^readonly VERSION=/ { print $$2}' $(rearbin))

ifneq ($(OFFICIAL),)
	distversion = $(version)
	debrelease = 0
	rpmrelease = %nil
	obsproject = Archiving:Backup:Rear
	obspackage = $(name)-$(version)

	date := $(shell date +%Y%m%d%H%M)
	release_date := $(shell date +%Y-%m-%d)
else
# Not official build, so we need to get the git info
# Some distros have older git, hence we need to do more processing
# of the output to get the exact same output on all the distros
	ifneq ($(wildcard .git),)
		ifneq ($(shell type -p git),)
			git_date := $(shell git log -n 1 --format="%ai")
			git_ref := $(shell git rev-parse HEAD | cut -c 1-8)
			git_count := $(shell git rev-list HEAD --no-merges | wc -l)
			git_branch_suffix = $(shell git symbolic-ref HEAD | sed -e 's,^.*/,,' -e "s/[^A-Za-z0-9]//g")
			git_status := $(shell git status --porcelain)
			git_stamp := $(git_count).$(git_ref).$(git_branch_suffix)
			ifneq ($(git_status),)
				git_stamp := $(git_stamp).changed
			endif # git_status
		else # no git
			git_date := now
			git_ref := 0
			git_count := 0
			git_branch_suffix := unknown
			git_stamp := $(git_count).$(git_ref).$(git_branch_suffix)
		endif # has git
	endif # has .git
	git_stamp ?= 0.0.unknown

    distversion = $(version)-git.$(git_stamp)
    debrelease = 0git.$(git_stamp)
    rpmrelease = .git.$(git_stamp)
    obsproject = Archiving:Backup:Rear:Snapshot
    obspackage = $(name)

	date := $(shell date --date="$(git_date)" +%Y%m%d%H%M)
	release_date := $(shell date --date="$(git_date)" +%Y-%m-%d)
endif


BUILD_DIR = /var/tmp/build-$(name)-$(distversion)

prefix = /usr
sysconfdir = /etc
sbindir = $(prefix)/sbin
datadir = $(prefix)/share
mandir = $(datadir)/man
localstatedir = /var

specfile = packaging/rpm/$(name).spec
dscfile = packaging/debian/$(name).dsc

# Spec file that will be actually used to build the package
# - a bit modified from the source $(specfile)
effectivespecfile = $(name)-$(distversion)/$(specfile)

rpmdefines =    --define="_topdir $(BUILD_DIR)/rpmbuild" \
		--define="debug_package %{nil}"

ifeq ($(shell id -u),0)
RUNASUSER := runuser -u nobody --
else
RUNASUSER :=
endif

# .gitignore is optional, avoid tar errors if it does not exist, e.g. in a dist archive
tarparams = $(shell test -f .gitignore && echo --exclude-from=.gitignore --exclude=.gitignore) --exclude=".??*" $(DIST_CONTENT)

DIST_FILES := $(shell tar -cv -f /dev/null $(tarparams))

.PHONY: doc dump package

all:
	@echo "Nothing to build. Use 'make help' for more information."

help:
	@echo -e "Relax-and-Recover make targets:\n\
\n\
  version         - Show ReaR version used\n\
  validate        - Check source code\n\
  install         - Install Relax-and-Recover (may replace files)\n\
  uninstall       - Uninstall Relax-and-Recover (may remove files)\n\
  dist            - Create tar file in dist/\n\
  dist-install    - Create tar file in dist and use that to install via make install\n\
                    We use this to install from checkout with correct version\n\
  package         - Create DEB/PM/Pacman package in dist/\n\
  deb             - Create DEB package in dist/\n\
  rpm             - Create RPM package in dist/\n\
  pacman          - Create Pacman package\n\
  obs             - Initiate OBS builds\n\
  dump            - Dump Makefile variables\n\
\n\
Relax-and-Recover make variables (optional):\n\
\n\
  DESTDIR=        - Location to install/uninstall\n\
  OFFICIAL=1      - Build an official release\n\
  \n\
"

version:
	@echo $(distversion)

dump:
# found at https://www.cmcrossroads.com/article/dumping-every-makefile-variable
	$(foreach V, $(sort $(.VARIABLES)), $(if $(filter-out environment% default automatic, $(origin $V)),$(info $V=$($V) defined as >$(value $V)<)))

clean:
	rm -Rf dist etc/os.conf etc/site.conf var build-stamp
	$(MAKE) -C doc clean

clean-all: clean
	rm -Rf $(BUILD_DIR)

### You can call 'make validate' directly from your .git/hooks/pre-commit script
validate:
	@echo -e "\033[1m== Validating scripts and configuration ==\033[0;0m"
	find etc/ usr/share/rear/conf/ -name '*.conf' | xargs -n 1 $(SHELL) -n
	$(SHELL) -n $(rearbin)
	find . -name '*.sh' | xargs -n 1 $(SHELL) -O extglob -O nullglob -n
	find usr/share/rear -name '*.sh' | grep -v -E '(lib|skel|conf)' | while read FILE ; do \
		num=$$(echo $${FILE##*/} | cut -c1-3); \
		if [[ "$$num" = "000" || "$$num" = "999" ]] ; then \
			echo "ERROR: script $$FILE may not start with $$num"; \
			exit 1; \
		else \
			if $$( grep '[_[:alpha:]]' <<< $$num >/dev/null 2>&1 ) ; then \
				echo "ERROR: script $$FILE must start with 3 digits"; \
				exit 1; \
			fi; \
		fi; \
	done

man:
	@echo -e "\033[1m== Prepare manual ==\033[0;0m"
	$(MAKE) -C doc man

doc:
	@echo -e "\033[1m== Prepare documentation ==\033[0;0m"
	$(MAKE) -C doc docs

install-config:
	@echo -e "\033[1m== Installing configuration ==\033[0;0m"
	install -d -m0700 $(DESTDIR)$(sysconfdir)/rear/
	install -d -m0700 $(DESTDIR)$(sysconfdir)/rear/cert/
	-[[ ! -e $(DESTDIR)$(sysconfdir)/rear/local.conf ]] && \
		install -Dp -m0600 etc/rear/local.conf $(DESTDIR)$(sysconfdir)/rear/local.conf
	-[[ ! -e $(DESTDIR)$(sysconfdir)/rear/os.conf && -e etc/rear/os.conf ]] && \
		install -Dp -m0600 etc/rear/os.conf $(DESTDIR)$(sysconfdir)/rear/os.conf
	-find $(DESTDIR)$(sysconfdir)/rear/ -name '.gitignore' -exec rm -rf {} \; &>/dev/null

install-bin:
	@echo -e "\033[1m== Installing binary ==\033[0;0m"
	install -Dp -m0755 $(rearbin) $(DESTDIR)$(sbindir)/rear
	sed -i -e 's,^CONFIG_DIR=.*,CONFIG_DIR="$$REAR_DIR_PREFIX$(sysconfdir)/rear",' \
		-e 's,^SHARE_DIR=.*,SHARE_DIR="$$REAR_DIR_PREFIX$(datadir)/rear",' \
		-e 's,^VAR_DIR=.*,VAR_DIR="$$REAR_DIR_PREFIX$(localstatedir)/lib/rear",' \
		-e 's,^LOG_DIR=.*,LOG_DIR="$$REAR_DIR_PREFIX$(localstatedir)/log/rear",' \
		$(DESTDIR)$(sbindir)/rear

install-data:
	@echo -e "\033[1m== Installing scripts ==\033[0;0m"
	rm -Rf $(DESTDIR)$(datadir)/rear
	install -d -m0755 $(DESTDIR)$(datadir)/rear/
	cp -a usr/share/rear/. $(DESTDIR)$(datadir)/rear/
	-find $(DESTDIR)$(datadir)/rear/ -name '.gitignore' -exec rm -rf {} \; &>/dev/null

install-var:
	@echo -e "\033[1m== Installing working directory ==\033[0;0m"
	install -d -m0755 $(DESTDIR)$(localstatedir)/lib/rear/
	install -d -m0755 $(DESTDIR)$(localstatedir)/log/rear/

install-doc:
	@echo -e "\033[1m== Installing documentation ==\033[0;0m"
	$(MAKE) -C doc install
	sed -i -e 's,/etc,$(sysconfdir),' \
		-e 's,/usr/sbin,$(sbindir),' \
		-e 's,/usr/share,$(datadir),' \
		-e 's,/usr/share/doc/packages,$(datadir)/doc,' \
		$(DESTDIR)$(mandir)/man8/rear.8

install: validate man install-config install-bin install-data install-var install-doc

uninstall:
	@echo -e "\033[1m== Uninstalling Relax-and-Recover ==\033[0;0m"
	-rm -v $(DESTDIR)$(sbindir)/rear
	-rm -v $(DESTDIR)$(mandir)/man8/rear.8
	-rm -rv $(DESTDIR)$(datadir)/rear/
#	rm -rv $(DESTDIR)$(sysconfdir)/rear/
#	rm -rv $(DESTDIR)$(localstatedir)/lib/rear/

dist: clean validate man dist/$(name)-$(distversion).tar.gz

# most of the sed stuff should be skipped if $(distversion) == $(version)
# except RELEASE_DATE= and perhaps the Version in $(dscfile)
dist/$(name)-$(distversion).tar.gz: $(DIST_FILES)
	@echo -e "\033[1m== Building archive $(name)-$(distversion) ==\033[0;0m"
	rm -Rf $(BUILD_DIR)/$(name)-$(distversion)
	mkdir -p dist $(BUILD_DIR)/$(name)-$(distversion)
	tar -c $(tarparams) | tar -C $(BUILD_DIR)/$(name)-$(distversion) -x
	@echo -e "\033[1m== Rewriting $(BUILD_DIR)/$(name)-$(distversion)/{$(specfile),$(dscfile),$(rearbin)} ==\033[0;0m"
	sed -i \
		-e 's#^\(Source0\?\):.*#\1: $(name)-${distversion}.tar.gz#' \
		-e 's#^Version:.*#Version: $(version)#' \
		-e 's#^%define rpmrelease.*#%define rpmrelease $(rpmrelease)#' \
		-e 's#^%setup.*#%setup -q -n $(name)-$(distversion)#' \
		-e 's#^%\(autosetup.*\)#%\1 -n $(name)-$(distversion)#' \
		$(BUILD_DIR)/$(effectivespecfile)
	sed -i \
		-e 's#^Version:.*#Version: $(version)-$(debrelease)#' \
		$(BUILD_DIR)/$(name)-$(distversion)/$(dscfile)
	sed -i \
		-e 's#^readonly VERSION=.*#readonly VERSION=$(distversion)#' \
		-e 's#^readonly RELEASE_DATE=.*#readonly RELEASE_DATE="$(release_date)"#' \
		$(BUILD_DIR)/$(name)-$(distversion)/$(rearbin)
	tar -czf dist/$(name)-$(distversion).tar.gz -C $(BUILD_DIR) $(name)-$(distversion)

# make install from dist tarball, to get a clean install without any build artifacts
dist-install: dist/$(name)-$(distversion).tar.gz
	mkdir -p $(BUILD_DIR)/dist-install
	tar -C $(BUILD_DIR)/dist-install -xvzf dist/$(name)-$(distversion).tar.gz --strip-components 1
	$(MAKE) -C $(BUILD_DIR)/dist-install install

package-clean:
	rm -f dist/*.rpm dist/*.deb dist/*.pkg.*

# TODO: It might be better to set BUILD_DIR=/tmp/rear-<packagetype>-$(distversion) to separate
# outer build dir from the package build dir, thereby enabling the make clean to also delete
# the BUILD_DIR correctly.

ifneq ($(shell type -p pacman),)
package: package-clean pacman
else ifneq ($(shell type -p dpkg),)
package: package-clean deb
else ifneq ($(shell type -p rpm),)
package: package-clean rpm
else
package:
	$(error Cannot determine package manager)
endif

# Note, older rpm checks file ownership, so we copy dist tarball to build dir first for Docker builds
# and we also copy the extracted files to build dir
# (tar -x preserves file ownership and with Docker the ownership is wrong, cp resets it)
srpm: dist/$(name)-$(distversion).tar.gz
	@echo -e "\033[1m== Building SRPM package $(name)-$(distversion) ==\033[0;0m"
	rm -rf $(BUILD_DIR)
	mkdir -p $(BUILD_DIR)
	cp dist/$(name)-$(distversion).tar.gz $(BUILD_DIR)/
	tar -xz -C $(BUILD_DIR)/ -f dist/$(name)-$(distversion).tar.gz $(dir $(effectivespecfile))
	cp $(BUILD_DIR)/$(dir $(effectivespecfile))/* $(BUILD_DIR)/
	if test "$(savedspecfile)"; then cp $(BUILD_DIR)/$(notdir $(effectivespecfile)) "$(savedspecfile)"; fi
	rpmbuild -bs --clean --nodeps \
		--define="_sourcedir $(BUILD_DIR)/" \
		--define="_srcrpmdir $(CURDIR)/dist" \
		$(rpmdefines) \
		$(BUILD_DIR)/$(notdir $(effectivespecfile))

# Temporary file passed to 'srpm', where the spec file will be available
# even after removing BUILD_DIR
rpm: savedspecfile := $(shell mktemp --suffix .spec)
# uniq because if we ever use subpackages, there will be multiple identical lines, one per each subpackage
# the rpmspec tool with --srpm would be preferable - it queries the source RPM information,
# but unfortunately it does not exist yet on EL6.
rpm: NEVR = $(name)-$(shell rpm -q $(rpmdefines) --queryformat '%{EVR}' --specfile "$(savedspecfile)" | uniq)
rpm: srpm
	@echo -e "\033[1m== Building RPM package $(NEVR) ==\033[0;0m"
	rpmbuild --rebuild --clean \
		--define="_rpmdir $(CURDIR)/dist" \
		--define "_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}.%%{ARCH}.rpm" \
		$(rpmdefines) \
		dist/$(NEVR).src.rpm
	rm -f $(savedspecfile)

deb: dist/$(name)-$(distversion).tar.gz
	@echo -e "\033[1m== Building DEB package $(name)-$(distversion) ==\033[0;0m"
	rm -rf $(BUILD_DIR)
	mkdir -p $(BUILD_DIR)
	tar -C $(BUILD_DIR) -xzf dist/$(name)-$(distversion).tar.gz
	cd $(BUILD_DIR)/$(name)-$(distversion) ; mv packaging/debian/ .
	cd $(BUILD_DIR)/$(name)-$(distversion) ; dch -v $(distversion) -b -M $(BUILD_DIR) package
	cd $(BUILD_DIR)/$(name)-$(distversion) ; debuild -us -uc -i -b --lintian-opts --profile debian
	mv $(BUILD_DIR)/$(name)_*.deb dist/

pacman: BUILD_DIR = /tmp/rear-$(distversion)
pacman: dist/$(name)-$(distversion).tar.gz

## rear 2.9+dfsg

=== doc/Makefile ===
SHELL=/bin/bash

# disable parallel execution of make
.NOTPARALLEL:

prefix = /usr
datadir = $(prefix)/share
mandir = $(datadir)/man

adoctargets = $(shell echo *.adoc)
htmltargets = $(patsubst %.adoc, %.html, $(adoctargets))

# asciidoctor is in Ruby and used on Debian and SUSE and can generate manpages directly
# asciidoc is in Python and used on Fedora and RHEL and cannot generate manpages, so we use xmlto to convert docbooc to manpage
asciidoc := $(shell if type -p asciidoctor >/dev/null; then echo asciidoctor; else echo asciidoc; fi)

all: docs

dist: docs

man: rear.8

docs: rear.8 $(htmltargets)
	make -C user-guide docs

install: rear.8
	install -Dp -m0644 rear.8 $(DESTDIR)$(mandir)/man8/rear.8

clean:
	rm -f unconv.8 *.html *.xml
	make -C user-guide clean

%.8.html: %.8.adoc
	$(asciidoc) -a footer-style=none -d manpage $<

ifeq ($(asciidoc),asciidoc)
%.8.xml: %.8.adoc
	$(asciidoc) -b docbook -d manpage $<

%.8: %.8.xml
	xmlto man $<
else
%.8: %.8.adoc
	$(asciidoc) -b manpage -d manpage $<
endif

%.html: %.adoc
	$(asciidoc) -a footer-style=none $<

=== doc/user-guide/Makefile ===
SHELL=/bin/bash

# disable parallel execution of make
.NOTPARALLEL:

prefix = /usr
datadir = $(prefix)/share
mandir = $(datadir)/man

adoctargets = relax-and-recover-user-guide.adoc
htmltargets = $(patsubst %.adoc, %.html, $(adoctargets))

asciidoc := $(shell if type -p asciidoctor >/dev/null; then echo asciidoctor; else echo asciidoc; fi)

all: docs

dist: docs

docs: $(htmltargets)

clean:
	rm -f *.html *.svg *.xml

%.html: %.adoc
	$(asciidoc) -a footer-style=none $<

=== debian/changelog ===
rear (2.9+dfsg-3) unstable; urgency=medium

  * [b5665b7] d/control: Adjustment of dependencies 
              after consultation with the upstream developers.

 -- Karsten Schöke <karsten.schoeke@geobasis-bb.de>  Fri, 28 Nov 2025 13:21:56 +0100

rear (2.9+dfsg-2) unstable; urgency=medium

  * [0ddf9f7] d/changelog: fix lintian error
  * [9a1961a] d/watch: switch to v5 format.
  * [9ef50f9] d/control: change Architecture list
              (Closes: #898970)
  * [c8177c4] d/gbp.conf: enable pristine-tar
  * [0b1dba1] insert 0004-systemd-service-file-refers-to-obsolete-bindto.patch
  * [265323e] d/rules: Delete all unnecessary readme files
  * [e60ddb2] update rear.lintian-overrides

 -- Karsten Schöke <karsten.schoeke@geobasis-bb.de>  Mon, 24 Nov 2025 15:33:48 +0100

rear (2.9+dfsg-1) unstable; urgency=medium

  * [19a78c2] New upstream version 2.9
  * [25b31be] insert d/gbp.conf
  * [778c6a8] reogranize patches.
  * [2545d81] insert 0003-Fix-ascidoctor-error.patch
  * [14fdf98] add myself to maintainer, adopt package.
              (Closes: #1117169)
  * [4091f56] d/control: bump standards and drop "Rules-Requires-Root: no"
              default since dpkg 1.22.13
  * [a404afe] remove double man build.
  * [778adb5] update lintian overrides.
  * [bf1fd6c] enable salsa CI gitlab config.
  * [46c11bd] Drop Multi-Arch: same to avoid DEP17 P7
              (multiarch same shared file loss) thx Chris Hofstaedtler
              (Closes: #1056938)
  * [9932cb9] improvement doc build @all
  * [10627eb] Update copyright and add myself
  * [c33e4f8] d/control: remove obsolete util-linux.

 -- Karsten Schöke <karsten.schoeke@geobasis-bb.de>  Tue, 07 Oct 2025 13:19:39 +0200

=== debian/control ===
Source: rear
Section: admin
Priority: optional
Maintainer: Karsten Schöke <karsten.schoeke@geobasis-bb.de>
Build-Depends: asciidoctor, debhelper-compat (= 13), xmlto
Build-Depends-Indep: source-highlight
Standards-Version: 4.7.2
Homepage: https://relax-and-recover.org/
Vcs-Browser: https://salsa.debian.org/debian/rear
Vcs-Git: https://salsa.debian.org/debian/rear.git

Package: rear-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Bare metal disaster recovery and system migration framework (documentation)
 It is a modular framework with many ready-to-go workflows for common
 situations.  Relax-and-Recover produces a bootable image. This image can
 repartition the system. Once that is done it initiates a restore from backup.
 Restores to different hardware are possible. Relax-and-Recover can therefore be
 used as a migration tool as well.
 .
 This package contains the documentation of rear.

Package: rear
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: attr,
         bc,
         binutils,
         cpio,
         dosfstools,
         e2fsprogs,
         ethtool,
         fdisk,
         file,
         gawk,
         gdisk,
         iproute2,
         iputils-ping,
         isolinux,
         kbd,
         lsb-release,
         net-tools,
         nfs-common,
         openssl,
         parted,
         procps,
         psmisc,
         syslinux[i386 amd64],
         syslinux-common,
         syslinux-efi,
         xorriso,
         ${misc:Depends}
Recommends: nfs-client, portmap, extlinux [amd64 i386]
Description: Bare metal disaster recovery and system migration framework
 It is a modular framework with many ready-to-go workflows for common
 situations.  Relax-and-Recover produces a bootable image. This image can
 repartition the system. Once that is done it initiates a restore from backup.
 Restores to different hardware are possible. Relax-and-Recover can therefore be
 used as a migration tool as well.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -Nrear-doc

execute_after_dh_auto_build:
	$(MAKE) doc

override_dh_install:
	gunzip debian/tmp/usr/share/rear/skel/Debian/default.tar.gz
	gzip -n debian/tmp/usr/share/rear/skel/Debian/default.tar
	rm -fr debian/tmp/usr/share/rear/conf/examples
	find debian/tmp/usr/share/rear -type f -iname "readme" -delete
	dh_install

override_dh_fixperms:
	# Stick to install-config permissions
	dh_fixperms --exclude debian/rear/etc/rear

=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/rear/rear/git/matching-refs/tags/
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/release/@ANY_VERSION@
Download-Url-Mangle: s%api.github.com/repos/([^/]+/[^/]+)/git/refs/tags/release/@ANY_VERSION@%github.com/$1/archive/refs/tags/release/$2.tar.gz%g
Filename-Mangle: s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Search-Mode: plain
Dversionmangle: s/\+dfsg\d*$//
Repacksuffix: +dfsg
